Debian Bug report logs - #411838
e2fsprogs: fsck.ext3 can end up looping

version graph

Package: e2fsprogs; Maintainer for e2fsprogs is Theodore Y. Ts'o <tytso@mit.edu>; Source for e2fsprogs is src:e2fsprogs.

Reported by: Tollef Fog Heen <tfheen@err.no>

Date: Wed, 21 Feb 2007 10:45:06 UTC

Severity: normal

Found in version e2fsprogs/1.39+1.40-WIP-2006.11.14+dfsg-2etch1

Fixed in version 1.39+1.40-wip-2007.04.07+dfsg-1

Done: "Theodore Ts'o" <tytso@mit.edu>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#411838; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Tollef Fog Heen <tfheen@err.no>:
New Bug report received and forwarded. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Tollef Fog Heen <tfheen@err.no>
To: submit@bugs.debian.org
Subject: e2fsprogs: fsck.ext3 can end up looping
Date: Wed, 21 Feb 2007 11:43:55 +0100
Package: e2fsprogs

In lib/ext2fs/icount.c(get_icount_el) there is some code which looks 
like this:

                        /* Interpolate for efficiency */
                        lowval = icount->list[low].ino;
                        highval = icount->list[high].ino;

                        if (ino < lowval)
                                range = 0;
                        else if (ino > highval)
                                range = 1;
                        else
                                range = ((float) (ino - lowval)) /
                                        (highval - lowval);
                        mid = low + ((int) (range * (high-low)));

I had a file system where range ended up being 1.0f, low being 0 and 
high being a large number.

Due to how floating point works, this meant mid ended up being > high 
and the while loop never terminated.

Clamping the mid value to be <= high and >= low fixed this problem.

- tfheen



Tags added: pending Request was from Theodore Y. Ts'o <tytso@mit.edu> to control@bugs.debian.org. (Mon, 07 May 2007 20:39:06 GMT) Full text and rfc822 format available.

Reply sent to "Theodore Ts'o" <tytso@mit.edu>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Tollef Fog Heen <tfheen@err.no>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #12 received at 411838-done@bugs.debian.org (full text, mbox):

From: "Theodore Ts'o" <tytso@mit.edu>
To: 379695-done@bugs.debian.org, 408298-done@bugs.debian.org, 411838-done@bugs.debian.org, 412614-done@bugs.debian.org
Subject: E2fsprogs bugs fixed by April 2007 upload
Date: Thu, 05 Jul 2007 15:02:33 -0400
Package: e2fsprogs
Version: 1.39+1.40-WIP-2007.04.07+dfsg-1

This version of e2fsprogs is not the latest upload of e2fsprogs (1.40-1
is the latest), but for some reasons a number of bugs associated with
this upload were never closed.

e2fsprogs (1.39+1.40-WIP-2007.04.07+dfsg-1) unstable; urgency=low

  * Add libreadline.so.5 support to libss.
  * Impove badblocks -n/-w exclusive usage message.
  * Add debugging code (via the COMERR_DEBUG env. variable) to the
      com_err library
  * Fix dump_unused segfault in debugfs when a filesystem is not open
  * Add versioned dependency in Debian's shlibs for libblkid.  
      (Closes: #413208)
  * Fix memory leak in blkid library.  (Closes: #413661)
  * Let the debugfs lcd command work even if a filesystem is not open
  * Fix large number of miscellaneous Coveriy bugs.  (None were
      security-security).
  * Fix e2fsck to clear i_size for special devices with a bogus i_blocks
      field on the first pass.
  * Fix e2fsck to set the file type of the '..' entry when connecting
      a directory to lost+found.
  * Enhance e2fsck to recover directories whose modes field were
      corrupted to look like special files.
  * Allow debugfs to dump > 2GB files.  (Closes: #412614)
  * Misc. man page cleanups.  (Closes: #379695)
  * Fix resize2fs parsing of size parameter (Closes: #408298)
  * Fix infinite loop in e2fsck on really big filesystems (Closes: #411838)
  * Fix memory leak in ext2fs_write_new_inode()
  * Add support for using a scratch files directory to reduce e2fsck's
      memory utilization on really big filesystems.

 -- Theodore Y. Ts'o <tytso@mit.edu>  Sat,  7 Apr 2007 10:38:40 -0400



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 03 Aug 2007 07:33:06 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Axel Beckert <beckert@phys.ethz.ch> to control@bugs.debian.org. (Sat, 20 Dec 2008 23:42:03 GMT) Full text and rfc822 format available.

Bug marked as found in version 1.39+1.40-WIP-2006.11.14+dfsg-2etch1. Request was from Axel Beckert <beckert@phys.ethz.ch> to control@bugs.debian.org. (Sat, 20 Dec 2008 23:42:04 GMT) Full text and rfc822 format available.

Tags added: etch Request was from Axel Beckert <beckert@phys.ethz.ch> to control@bugs.debian.org. (Sat, 20 Dec 2008 23:42:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#411838; Package e2fsprogs. (Sat, 20 Dec 2008 23:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <beckert@phys.ethz.ch>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). (Sat, 20 Dec 2008 23:48:03 GMT) Full text and rfc822 format available.

Message #25 received at 411838@bugs.debian.org (full text, mbox):

From: Axel Beckert <beckert@phys.ethz.ch>
To: 411838@bugs.debian.org
Cc: control@bugs.debian.org, 411838-subscribe@bugs.debian.org, debian-release@lists.debian.org
Subject: #411838: Please fix this bug (e2fsprogs: fsck.ext3 can end up looping) also in Etch
Date: Sun, 21 Dec 2008 00:35:20 +0100
unarchive 411838
found 411838 1.39+1.40-WIP-2006.11.14+dfsg-2etch1
tag 411838 +etch
thanks

Hi,

this bug seems also present in the current stable release. I ran into it
after the recent kernel upgrade for Etch. Since this bug can cause
unexpected downtime durations when it appears, I think this should be
fixed in Etch, too.

Symptom here on amd64 Etch: fsck for one 2.2 TB partition _always_ hangs
at exactly 70.0% and while fsck was mostly diskwaiting and used about
2-3% CPU before reaching 70.0%, it uses up 100% CPU after reaching 70.0%
(no system or library calls anymore at that point), and never ends. (I
waited several hours once.) This happens at boot up, in single user mode
as well as when I boot up without this partition and then run fsck
manually.

Since backporting e2fsprogs from Lenny to Etch didn't work out of the
box (FTBFS on Etch), I installed 1.39+1.40-wip-2007.04.07+dfsg-2 from
snapshot.debian.net as a workaround. The bug was originally fixed in
1.39+1.40-wip-2007.04.07+dfsg-1.

TIA.

		Kind regards, Axel Beckert
-- 
Axel Beckert <beckert@phys.ethz.ch>       support: +41 44 633 2668
IT Support Group, HPT D17 (new address!)  voice:   +41 44 633 4189
Departement Physik, ETH Zurich            fax:     +41 44 633 1239
CH-8093 Zurich, Switzerland		  http://nic.phys.ethz.ch/




Tags removed: etch Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Sun, 21 Dec 2008 00:36:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#411838; Package e2fsprogs. (Sun, 11 Jan 2009 15:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Adeodato Simó <dato@net.com.org.es>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). (Sun, 11 Jan 2009 15:51:02 GMT) Full text and rfc822 format available.

Message #32 received at 411838@bugs.debian.org (full text, mbox):

From: Adeodato Simó <dato@net.com.org.es>
To: Theodore Ts'o <tytso@mit.edu>
Cc: 411838@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: #411838: Please fix this bug (e2fsprogs: fsck.ext3 can end up looping) also in Etch
Date: Sun, 11 Jan 2009 16:49:00 +0100
> this bug seems also present in the current stable release. I ran into it
> after the recent kernel upgrade for Etch. Since this bug can cause
> unexpected downtime durations when it appears, I think this should be
> fixed in Etch, too.

Theodore, any comment about including a fix for #411838 in Etch? Would
you be able to upload fixed packges?

> Symptom here on amd64 Etch: fsck for one 2.2 TB partition _always_ hangs
> at exactly 70.0% and while fsck was mostly diskwaiting and used about
> 2-3% CPU before reaching 70.0%, it uses up 100% CPU after reaching 70.0%
> (no system or library calls anymore at that point), and never ends. (I
> waited several hours once.) This happens at boot up, in single user mode
> as well as when I boot up without this partition and then run fsck
> manually.

> Since backporting e2fsprogs from Lenny to Etch didn't work out of the
> box (FTBFS on Etch), I installed 1.39+1.40-wip-2007.04.07+dfsg-2 from
> snapshot.debian.net as a workaround. The bug was originally fixed in
> 1.39+1.40-wip-2007.04.07+dfsg-1.

> TIA.

> 		Kind regards, Axel Beckert

-- 
Adeodato Simó                                     dato at net.com.org.es
Debian Developer                                  adeodato at debian.org
 
The true teacher defends his pupils against his own personal influence.
                -- Amos Bronson Alcott





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 09 Feb 2009 07:28:00 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 13:21:04 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.